/*
 *  Annealing.h
 *  alife-xcode30
 *
 *  Created by Eduardo Poyart on 2/22/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

class Annealing
{
public:
	Annealing(Simulator* sim):
		m_sim(sim), m_model(&sim->get_model()), m_nn(sim->get_model().get_nn()), m_fj(sim->get_model().get_fj()),
		m_t(1.0), m_best_fitness(0.0), m_prev_nn(*sim->get_model().get_nn()), m_prev_fj(*sim->get_model().get_fj()), 
		m_stop(false), m_abort(false),
		m_time(100.0), m_total_time(5.0), m_cycle_count(0), m_step_counter(0) { sim->get_model().reset(); }
	virtual ~Annealing() {}
	void init();
	void step();
	void set_stop(bool val) { m_stop = val; }
	void set_abort() { m_abort = true; }

protected:
	Simulator* m_sim;
	Model* m_model;
	NeuralNet* m_nn;
	FourierJoint* m_fj;
	real m_t;
	real m_best_fitness;
	NeuralNet m_prev_nn;
	FourierJoint m_prev_fj;
	bool m_stop;
	bool m_abort;
	real m_time;
	real m_total_time;
	int m_cycle_count;
	int m_step_counter;
	ofstream m_ofs;
	
	void random_change();
	bool should_change_state()
	{
		return ((real)rand() / RAND_MAX) < m_t;
	}
	real fitness_snowboarder();
	real fitness_spider();
	real fitness_cyclist();
	void save_and_exit();
	bool force_stop();
};
