/*
 *  FourierJoint.cpp
 *  alife
 *
 *  Created by Eduardo Poyart on 3/9/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#include "alife_Prefix.pch"
#include "common.h"

#define TIME_CONSTANT 9.0

real FourierJoint::get_torque(int index, real time)
{
	real result = 0.0;
	for (int i = 0; i < m_nterms; i++)
		result += (m_params(index, i).amplitude / (i+1)) * cos((i+1) * (time * TIME_CONSTANT + m_params(index, i).phase));
	return result;
}

void FourierJoint::save(const char* filename)
{
	ofstream ofs;
	ofs.open(filename, ios::out);
	if (!ofs.good())
	{
		cout << "Error opening output file." << endl;
		exit(1);
	}
	ofs << m_params.m << " " << m_params.n << endl;
	for (int i = 0; i < m_params.m; i++)
		for (int j = 0; j < m_params.n; j++)
			ofs << m_params(i, j).amplitude << " " << m_params(i, j).phase << endl;
	ofs.close();
}

void FourierJoint::load(const char* filename)
{
	ifstream ifs;
	ifs.open(filename, ios::in);
	if (!ifs.good())
	{
		cout << "Error opening input file." << endl;
		exit(1);
	}
	int m, n;
	ifs >> m >> n;
	m_params.resize(m, n);
	for (int i = 0; i < m_params.m; i++)
		for (int j = 0; j < m_params.n; j++)
			ifs >> m_params(i, j).amplitude >> m_params(i, j).phase;
	ifs.close();
}
