/*
 *  FourierJoint.h
 *  alife
 *
 *  Created by Eduardo Poyart on 3/9/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

struct FCoeff
{
	real amplitude;
	real phase;
};

class FourierJoint
{
public:
	int m_nindexes;
	int m_nterms;
	Array2d<FCoeff> m_params;
	
	FourierJoint(int in_nindexes): 
		m_nindexes(in_nindexes),
		m_nterms(2),
		m_params(in_nindexes, m_nterms)
		{ memset(m_params.a, 0, m_params.m * m_params.n * sizeof(FCoeff)); }
	const FourierJoint& operator=(const FourierJoint& fj) 
	{
		assert(this != &fj);
		m_nindexes = fj.m_nindexes; m_nterms = fj.m_nterms; m_params = fj.m_params;
		return *this;
	}
	
	real get_torque(int index, real time);
	int parameter_space() { return m_nindexes * m_nterms * 2; }
	real* parameter(int index) 
	{
		assert(index < m_nindexes * m_nterms * 2); 
		return ((real*)(&m_params.a[index/2])) + (index % 2);
	};
	void save(const char* filename);
	void load(const char* filename);
};
