/*
 *  Mesh.h
 *  alife
 *
 *  Created by Eduardo Poyart on 3/18/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

class Mesh
{
protected:
	int m_nx;
	int m_ny;
	real m_spacing;
	Array2d<real> m_hmap;
	dGeomID m_geom;
	dTriMeshDataID m_trimesh;
	int m_num_indexes;
	dTriIndex* m_indexes;
	int m_num_verts;
	dReal* m_verts;
	real* m_normals;
	
public:
	Mesh(int nx, int ny, real spacing): m_nx(nx), m_ny(ny), m_spacing(spacing), m_hmap(nx, ny) {}
	void init(dSpaceID in_space);
	void draw();
	dGeomID get_geom() { return m_geom; }
	
protected:
	void interpolate(int step);
	void interpolate_row(int i0, int i1, int j);
	void interpolate_col(int i, int j0, int j1);
	void create_ode_trimesh(dSpaceID in_space);
};
