/*
 *  Parser.h
 *  mocapview
 *
 *  Created by Eduardo Poyart on 2/3/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

class Parser
{
public:
	Parser(ifstream* ifs): f(ifs), delimiters("=\"\',;<>"), blank(" \t\n\r"), bufpos(0), delim_flag(false)
		{ assert(ifs->good()); buf[0] = '\0'; }
	virtual ~Parser() {}
	
	void set_delimiters(const string& i_delimiters) {delimiters = i_delimiters;}
	void set_blank(const string& i_blank) {blank = i_blank;}
	
	string get_token()
	{
		if (buf[bufpos] == '\0')
		{
			if (f->eof())
			{
				cout << "End of stream" << endl;
				return "";
			}
			f->width(80);
			*f >> buf;
			bufpos = 0;
		}
		string sbuf(buf+bufpos);
		assert(sbuf.size() > 0);
		size_t i = sbuf.find_first_of(delimiters);
		if (i == 0)
		{
			i = 1;
			delim_flag = true;
		}
		else
		{
			delim_flag = false;
		}
		if (i == string::npos)
			i = sbuf.size();
		bufpos += i;
		return sbuf.substr(0, i);
	}
	
	bool is_delimiter() { return delim_flag; }
	
	bool find_token(const string& s, bool exit_on_error = true)
	{
		assert(s != "");
		string fs("");
		while (s != fs && !f->eof())
			fs = get_token();
		if (f->eof())
		{
			if (exit_on_error)
			{
				cout << "Error parsing file" << endl;
				exit(1);
			}
			return false; // not found
		}
		return true; // found
	}
	
protected:
	ifstream* f;
	string delimiters;
	string blank;
	char buf[80];
	int bufpos;
	bool delim_flag;
};
