/*
 *  Simulator.h
 *  alife
 *
 *  Created by Eduardo Poyart on 2/17/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

class Simulator
{
public:
	Simulator(): m_mesh(33, 33, 1.0) { dInitODE(); }
	virtual ~Simulator() { dCloseODE(); }
	
	void init();
	void generate_ground(const Vector3& translation, const Vector4& rotation, const Vector3& scale, real rand_up, real pos_z);
	void init_opengl();
	void reshape(int width, int height);
	void step(real t);
	void draw();
	Model& get_model() { return m_model; }
	void keypress(unsigned char key, int x, int y);
	void mouse_button(int button, int state, int x, int y);
	void mouse_drag(int x, int y);
	
protected:
	real m_width;
	real m_height;
	real m_aspect;
	
	dWorldID m_world;
	vector<dGeomID> m_ground;
	dSpaceID m_space;
	dJointGroupID m_contactgroup;
	
	real m_rot_x;
	real m_rot_z;
	real m_cam_dist;
	int m_prev_mouse_x;
	int m_prev_mouse_y;
	
	Model m_model;
	Mesh m_mesh;
	Timer m_timer;
	
	Vector3 m_pick;
	bool m_pickspring;
	Vector3 m_prev_model_pos;
	
	static void near_callback(void *data, dGeomID o1, dGeomID o2);
	Vector3 get_projection(int x, int y);
	bool is_ground(dGeomID g);

};
